function picopic_command(servo,command,data);
% function picopic_command(servo,command,data);
% 
% Example usage:
% picopic_command(servo0,'change baud',57600);
%   speed from the following list:
% 1200, 2400, 9600, 19200, 38400, 57600, 76800, 115200 (defaults to 9600)
% picopic_command(servo0,'change address',120);
%   address from 1 to 255
% picopic_command(servo0,'save all',0); // the data here doesn't matter
%   data doesn't matter
% picopic_command(servo0,'extend width',1); // extends the width
%   data is 0 or 1

extra=[];

switch lower(command)
case 'change baud'
    data1=char(21);
    switch data
    case 1200
        data2=char(01);
    case 2400
        data2=char(02);
    case 19200
        data2=char(04);
    case 38400
        data2=char(05);
    case 57600
        data2=char(06);
    case 76800
        data2=char(07);
    case 115200
        data2=char(08);
    otherwise
        data2=char(03);
    end
    extra=char([00 00]);
case 'change address'
    data1=char(22);
    if ((data<1)&(data>255))
        disp('You have to change to an address from 1-255');
        break;
    end
    data2=char(data);
    extra=char([00 00]);
case 'save all'
    data1=char(23);
    data2=char(00);
    extra=char([00 00]);
case 'extend width'
    data1=char(24);
    if ((data<0)&(data>1))
        disp('You have to either extend or disable extension (1 means max pulse range)');
        break;
    end
    if data==0
        data2=char(00);
    elseif data==1
        data2=char(01);
    end
    extra=char([00 00]);
otherwise
    disp('There was no valid command issued!');
    break;
end

s0=serial(servo.port,'BaudRate',servo.port_speed);
fopen(s0);
% whos
% disp(['#' address '-' channel '-' highpos '-' lowpos '-' speed '#'])
address=char(servo.address);
fwrite(s0,[address,data1,data2,extra],'uchar');

fclose(s0);
clear s0;

if (data1==char(21))
    servo.port_speed=data;
elseif (data1==char(22))
    servo.address=data;
end